<?php
class Games_Chess_Player
{
    var $name;
    var $games = array();
    var $ICCrating;
    function Games_Chess_Player($name, $gamesPlayed)
    {
        $this->name = $name;
        foreach ($gamesPlayed as $game) {
            $this->addGame($game);
        }
    }

    /**
     * @param Games_Chess_Result
     * @param white|black which side this player played
     * @link http://www.chessclub.com/help/ratings
     */
    function _calculateICCRating($game, $played)
    {
        if (!isset($this->ICCRating)) {
            $this->ICCRating = 1600;
        }
        $self = $this->ICCRating;
        $opponent = $game->{$played == 'white' ? 'black' : 'white'};
        if ($opponent['count'] < 20) {
            // opponent is provisional
            $K = 32 * (1 + $opponent['count']) / 21;
            $extra = 1/5 * (1600 - $self);
        } else {
            $K = 32;
            $extra = 0;
        }
        if ($this->gamesPlayed() < 20) {
            // provisional
            $rating = $opponent['rating'] + (400 * $game->result);
            $unaverage = count($this->games) * $this->ICCRating;
            $this->ICCRating = ($unaverage + $rating) / (count($this->games) + 1) + $extra;
            return;
        } else {
            $rating = $opponent['rating'];
            $this->ICCRating = $self +
                $K * (
                    $game->result -
                    1 / (
                            1 + pow(10, ($rating - $self) / 400)
                        )
                );
        }
    }

    function addGame($game)
    {
        if ($game->white['name'] = $this->name) {
            $this->_calculateICCRating($game, 'white');
            $this->games['W'] = $game;
        } elseif ($game->black['name'] = $this->name) {
            $this->_calculateICCRating($game, 'black');
            $this->games['B'] = $game;
        }
    }
}
?>